searchData={"content_type":"text/markdown","items":[{"doc":"","ref":"Ueberauth.Strategy.Microsoft.html","title":"Ueberauth.Strategy.Microsoft","type":"module"},{"doc":"","ref":"Ueberauth.Strategy.Microsoft.html#credentials/1","title":"Ueberauth.Strategy.Microsoft.credentials/1","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Microsoft.html#default_options/0","title":"Ueberauth.Strategy.Microsoft.default_options/0","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Microsoft.html#extra/1","title":"Ueberauth.Strategy.Microsoft.extra/1","type":"function"},{"doc":"Handles initial request for Microsoft authentication.","ref":"Ueberauth.Strategy.Microsoft.html#handle_request!/1","title":"Ueberauth.Strategy.Microsoft.handle_request!/1","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Microsoft.html#info/1","title":"Ueberauth.Strategy.Microsoft.info/1","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Microsoft.html#uid/1","title":"Ueberauth.Strategy.Microsoft.uid/1","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Microsoft.OAuth.html","title":"Ueberauth.Strategy.Microsoft.OAuth","type":"module"},{"doc":"","ref":"Ueberauth.Strategy.Microsoft.OAuth.html#authorize_url/2","title":"Ueberauth.Strategy.Microsoft.OAuth.authorize_url/2","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Microsoft.OAuth.html#authorize_url!/2","title":"Ueberauth.Strategy.Microsoft.OAuth.authorize_url!/2","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Microsoft.OAuth.html#client/1","title":"Ueberauth.Strategy.Microsoft.OAuth.client/1","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Microsoft.OAuth.html#get_token/3","title":"Ueberauth.Strategy.Microsoft.OAuth.get_token/3","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Microsoft.OAuth.html#get_token!/2","title":"Ueberauth.Strategy.Microsoft.OAuth.get_token!/2","type":"function"},{"doc":"# MIT License\n\nCopyright (c) 2017 Stuart Welham\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"# Überauth Microsoft\n\n[![Module Version](https://img.shields.io/hexpm/v/ueberauth_microsoft.svg)](https://hex.pm/packages/ueberauth_microsoft)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/ueberauth_microsoft/)\n[![License](https://img.shields.io/hexpm/l/ueberauth_microsoft.svg)](https://github.com/swelham/ueberauth_microsoft/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/swelham/ueberauth_microsoft.svg)](https://github.com/swelham/ueberauth_microsoft/commits/master)\n\n> Microsoft OAuth2 strategy for Überauth.\n\nQuick start blog post: [Authenticating users with Microsoft OAuth](https://www.stuartwelham.com/articles/authenticating-users-with-microsoft-oauth)","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"1.  Register an application in the Azure Portal ([see Microsoft tutorial for more info](https://learn.microsoft.com/en-us/azure/active-directory/develop/quickstart-register-app)).\n\n2.  Add `:ueberauth_microsoft` to your list of dependencies in `mix.exs`:\n\n    ```elixir\n    def deps do\n      [\n        {:ueberauth_microsoft, \"~> 0.22\"}\n      ]\n    end\n    ```\n\n3.  Add the strategy to your applications:\n\n    ```elixir\n    def application do\n      [\n        applications: [:ueberauth_microsoft]\n      ]\n    end\n    ```\n\n4.  Add Microsoft to your Überauth configuration:\n\n    ```elixir\n    config :ueberauth, Ueberauth,\n      providers: [\n        microsoft: {Ueberauth.Strategy.Microsoft, []}\n      ]\n    ```\n\n5.  Update your provider configuration:\n\n    ```elixir\n    config :ueberauth, Ueberauth.Strategy.Microsoft.OAuth,\n      client_id: System.get_env(\"MICROSOFT_CLIENT_ID\"),\n      client_secret: System.get_env(\"MICROSOFT_CLIENT_SECRET\")\n    ```\n\n6.  Include the Überauth plug in your controller:\n\n    ```elixir\n    defmodule MyApp.AuthController do\n      use MyApp.Web, :controller\n      plug Ueberauth\n      ...\n    end\n    ```\n\n7.  Create the request and callback routes if you haven't already:\n\n    ```elixir\n    scope \"/auth\", MyApp do\n      pipe_through :browser\n\n      get \"/:provider\", AuthController, :request\n      get \"/:provider/callback\", AuthController, :callback\n    end\n    ```\n\n8.  Your controller needs to implement callbacks to deal with `Ueberauth.Auth`\n    and `Ueberauth.Failure` responses.\n\nFor an example implementation see the [Überauth Example](https://github.com/ueberauth/ueberauth_example) application.","ref":"readme.html#installation","title":"Installation - Overview","type":"extras"},{"doc":"If you are going to use your app only internally you may need to configure it for a single tenant.\nTo do so you only need to add `tenant_id` to your provider configuration like:\n\n```elixir\nconfig :ueberauth, Ueberauth.Strategy.Microsoft.OAuth,\n  tenant_id: System.get_env(\"MICROSOFT_TENANT_ID\"),\n  client_id: System.get_env(\"MICROSOFT_CLIENT_ID\"),\n  client_secret: System.get_env(\"MICROSOFT_CLIENT_SECRET\")\n```","ref":"readme.html#single-tenancy","title":"Single Tenancy - Overview","type":"extras"},{"doc":"Depending on the configured url you can initial the request through:\n\n    /auth/microsoft\n\nBy default the scopes used are:\n\n- openid\n- email\n- offline_access\n- https://graph.microsoft.com/user.read\n\n_Note: at least one service scope is required in order for a token to be\nreturned by the Microsoft endpoint_\n\nYou can configure additional scopes to be used by passing the `extra_scopes`\noption into the provider:\n\n```elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    microsoft: {\n      Ueberauth.Strategy.Microsoft,\n      [extra_scopes: \"https://graph.microsoft.com/calendars.read\"]\n    }\n  ]\n```\n\nIf you would like users to have the option to choose an alternate account to authenticate with instead of defaulting to the logged in account, you may pass the `prompt` option in to the provider (per [Microsoft documentation](https://docs.microsoft.com/en-us/azure/active-directory/develop/v2-oauth2-auth-code-flow)):\n\n```elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    microsoft: {Ueberauth.Strategy.Microsoft, [prompt: \"select_account\"]}\n  ]\n```","ref":"readme.html#calling","title":"Calling - Overview","type":"extras"},{"doc":"Copyright (c) 2017 Stuart Welham\n\nReleased under the MIT License, which can be found in the repository in\n[LICENSE](./LICENSE.md).","ref":"readme.html#copyright-and-license","title":"Copyright and License - Overview","type":"extras"}]}